// Sprite.cpp: implementation of the Sprite class.
//
//////////////////////////////////////////////////////////////////////

#include "Sprite.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Sprite::Sprite(SDL_Surface* graphics)
{
	active = false;
	x = 0;
	y = 0;
	frames = graphics;
}

Sprite::~Sprite()
{
	frames = NULL;

	if (frameRect != NULL)
	{
		delete[] frameRect;
	}
	frameRect = NULL;
}

int Sprite::getX()
{
	return x;
}

void Sprite::setX(int value)
{
	x = value;
}

int Sprite::getY()
{
	return y;
}

void Sprite::setY(int value)
{
	y = value;
}

void Sprite::Draw(SDL_Surface * screen)
{
	if (active)
	{
		if (x >= 0)
			position.x = x;
		else
			position.x = 0;

		if (y >= 0)
			position.y = y;
		else
			position.y = 0;

		if (SDL_BlitSurface(frames, &frameRect[iFrame], screen, &position) < 0)
		{
			fprintf(stderr, "CSprite::Draw() BlitSurface Error:  %s\n", SDL_GetError());
		}
	}
}

int Sprite::getFrame()
{
	return iFrame;
}

void Sprite::setFrame(int value)
{
	iFrame = value;
}

bool Sprite::getActive()
{
	return active;
}

void Sprite::setActive(bool value)
{
	active = value;
}
