// Sprite.h: interface for the Sprite class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(SPRITE_H_INCLUDED)
#define SPRITE_H_INCLUDED

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <SDL.h>

class Sprite  
{
public:
	void setActive(bool value);
	bool getActive();
	void setFrame(int value);
	int getFrame();
	void Draw(SDL_Surface* screen);
	void setY(int value);
	int getY();
	void setX(int value);
	int getX();
	Sprite(SDL_Surface* graphics);
	virtual ~Sprite();
	virtual int getWidth() = 0;
	virtual int getHeight() = 0;
	virtual void update() = 0;

protected:
	SDL_Rect* frameRect;
	int iFrame;

private:
	bool active;
	virtual void InitFrames() = 0;
	int y;
	int x;
	SDL_Rect position;
	SDL_Surface* frames;
};

#endif // !defined(SPRITE_H_INCLUDED)
